#include "graphics.h"
#include "string.h"

#define FNX(x,y,theta) ((x)*cos(theta)-(y)*sin(theta));
#define FNY(x,y,theta) ((x)*sin(theta)+(y)*cos(theta));

#define OK    0
#define NOK  -1
	 /* ###################### 3D LIB ########################### */
float Alfa,Beta,Gamma; //angoli di rotazione assi x,y,z
float zoom;            //angoli di rotazione assi x,y,z
int   WMx,Wmx,WMy,Wmy; //Bordi della finestra ATTIVA per disegnare
int   XCC,YCC;         //Coord centro schermo
    /* ###################### 3D LIB ########################### */
//XC,YC coordinate nuova origine degli assi =0 se coincide con XCC,YCC

#include "3dfun.h"
#include "miemath.h"
ELEMENTS *iniz=NULL,*last=NULL,*iniz1=NULL,*last1=NULL;

//Aggiunge (non crea) un elemento (bisogna infatti mallocarlo prima)
//Cima=primo elemento (es. iniz) Fondo=ultimo elemento (es. last)
void Memor(struct Elements *punt,int Caso)
{
 if (Caso) {
    if (!last1) iniz1 = last1 = punt;
    else        last1->succ   = punt;
    punt->succ  = NULL;
    last1       = punt;
 }
 else {
    if (!last) iniz = last = punt;
    else        last->succ = punt;
    punt->succ = NULL;
    last       = punt;
 }
}

//Toglie (non cancella) un elemento (bisogna infatti freearlo poi)
struct Elements *Cancel(struct Elements *Prec,struct Elements *Canc,struct Elements *Cima)
{
//Prec= Elemento precedente, Canc=Elemento da Cancellare Cima=1Elemento lista
  if (Prec) Prec -> succ = Canc->succ;
  else      Cima = Canc->succ;

return Cima;
}

//Resetta elemento (pone tutto a 0)
void Reset(struct Elements *punt)
{
int i;

 for(i=0;i<8;i++) { punt->Obj.pti[i][0]=0; punt->Obj.pti[i][1]=0; punt->Obj.pti[i][2]=0; }
 for(i=0;i<3;i++) { punt->Centro[i]=0; punt->Lung[i]=0; }
 punt->Lon =0;
 punt->Lat =0;
 punt->Ray1=0;
 punt->Ray2=0;
 punt->color=0;
 punt->stato=0;
}

int Code (x,y,Minx,Maxx,Miny,Maxy)
float *x,*y,*Minx,*Maxx,*Miny,*Maxy;
{
typedef enum {null,minx,maxx,miny,maxy};
int c=null;

 if (*x<*Minx)       c = minx;
 else if (*x>*Maxx)  c = maxx;
 if (*y<*Miny)       c = c + miny;
 else if (*y>*Maxy)  c = c + maxy;

return c;
}

double ClipDX(Maxx,x,y,x0,y0)
register float *Maxx,*x,*y,*x0,*y0;
{
return ((*y0 - *y) / (*x0 - *x) * (*Maxx - *x) + *y);
}

double ClipSX(Minx,x,y,x0,y0)
register float *Minx,*x,*y,*x0,*y0;
{
return ((*y0 - *y) / (*x0 - *x) * (*Minx - *x) + *y);
}

double ClipTOP(Maxy,x,y,x0,y0)
register float *Maxy,*x,*y,*x0,*y0;
{
return ((*Maxy - *y) / (*y0 - *y) * (*x0 - *x) + *x);
}

double ClipBOT(Miny,x,y,x0,y0)
register float *Miny,*x,*y,*x0,*y0;
{
return ((*Miny - *y) / (*y0 - *y) * (*x0 - *x) + *x);
}

//portabile algoritmo di clipping
int clipping (x1,y1,x2,y2,Minx,Maxx,Miny,Maxy)
float *x1,*x2,*y1,*y2;
float *Minx,*Maxx,*Miny,*Maxy;
{
int c1,c2;
 //0=Interna  1=Meta-Meta 2=Esterna
 c1=Code(x1,y1,Minx,Maxx,Miny,Maxy); c2=Code(x2,y2,Minx,Maxx,Miny,Maxy);
 if (c1==0 && c2==0) return 0;
 if ((*y1>=*Maxy && *y2>=*Maxy) || (*y1<=*Miny && *y2<=*Miny)) return 2;
 if ((*x1>=*Maxx && *x2>=*Maxx) || (*x1<=*Minx && *x2<=*Minx)) return 2;
 if ((*x1>=*Maxx || *x2>=*Maxx)) {
	  if (*x1>=*Maxx) { *y1=ClipDX(Maxx,x1,y1,x2,y2); *x1=*Maxx;  }
	  if (*x2>=*Maxx) { *y2=ClipDX(Maxx,x2,y2,x1,y1); *x2=*Maxx;  }
 }
 if ((*x1<=*Minx || *x2<=*Minx)) {
	  if (*x1<=*Minx) { *y1=ClipSX(Minx,x1,y1,x2,y2); *x1=*Minx;  }
	  if (*x2<=*Minx) { *y2=ClipSX(Minx,x2,y2,x1,y1); *x2=*Minx;  }
 }
 if ((*y1>=*Maxy || *y2>=*Maxy)) {
	  if (*y1>=*Maxy) { *x1=ClipTOP(Maxy,x1,y1,x2,y2); *y1=*Maxy; }
	  if (*y2>=*Maxy) { *x2=ClipTOP(Maxy,x2,y2,x1,y1); *y2=*Maxy; }
 }
 if ((*y1<=*Miny || *y2<=*Miny)) {
	  if (*y1<=*Miny) { *x1=ClipBOT(Miny,x1,y1,x2,y2); *y1=*Miny; }
	  if (*y2<=*Miny) { *x2=ClipBOT(Miny,x2,y2,x1,y1); *y2=*Miny; }
 }
 c1=Code(x1,y1,Minx,Maxx,Miny,Maxy); c2=Code(x2,y2,Minx,Maxx,Miny,Maxy);
 if (c1!=0 || c2!=0) return 2;

 return 1;
}

//Conversione da Coord.Polari->Coord.Cartesiane
void POLtoXYZ (float Lon,float Lat,float Dis,float *x,float *y,float *z)
{
 Lon=GtoR(Lon);
 Lat=GtoR(Lat);
 *x=Dis*cos(Lon)*cos(Lat);
 *y=Dis*cos(Lat)*sin(Lon);
 *z=Dis*sin(Lat);
}

//Conversione da Coord.Cartesiane->Coord.Polari
void XYZtoPOL (float x,float y,float z,float *Lon,float *Lat,float *Dis)
{
 *Dis=sqrt(x*x+y*y+z*z);
 *Lat=M_PI/2-acos(z/(*Dis));
 *Lon=AcTan(y,x);
}

//Distanza 2 p.ti nello spazio
float Dist3D (float x1,float y1,float z1,float x,float y,float z)
{
return(sqrt((x1-x)*(x1-x)+(y1-y)*(y1-y)+(z1-z)*(z1-z)));
}


//Portabile rotazione rispetto ai 3 assi cartesiani
void ROTXYZ(float X,float Y,float Z,float *XT,float *YT,float *ZT)
{
float tempx,tempy;

 *XT=X;
 *YT=Y;
 *ZT=Z;

 if (Alfa) {
    tempy = *YT;
    *YT = FNX(tempy,Z,Alfa);
    *ZT = FNY(tempy,Z,Alfa);
 }
 if (Beta) {
    tempx = X;
    tempy = *ZT;
    *XT = FNX(tempx,tempy,Beta);
    *ZT = FNY(tempx,tempy,Beta);
 }
 if (Gamma){
    tempx = *XT;
    tempy = *YT;
    *XT = FNX(tempx,tempy,Gamma);
    *YT = FNY(tempx,tempy,Gamma);
 }
}

//Traslazione assi in 3D
void TRAXYZ (float *OldX,float *OldY,float *OldZ,float TraslaX,float TraslaY,float TraslaZ)
{
*OldX = *OldX + TraslaX;
*OldY = *OldY + TraslaY;
*OldZ = *OldZ + TraslaZ;
}


// Tracciamento di un punto in 3D
int Point3D(float xyz[],float XC,float YC,int color)
{
long int X,Y;

 X = XCC - (long int)XC + (long int)(zoom*xyz[0]);
 Y = YCC + (long int)YC - (long int)(zoom*xyz[1]);

 //Verifica che sia all'interno dei bordi dello schermo
 if ((X>Wmx && X<WMx) && (Y>Wmy && Y<WMy)) putpixel(X,Y,color);//interno
 else                                      return NOK;         //esterno

return OK;
}

// Inserimento di un testo relativo ad un punto in 3D
int OText3D(float xyz[],float XC,float YC,int color,char str[])
{
long int X,Y;
int      Col,lung,LS,sp1,sp2,i;
char     Str[30];

 X = XCC - (long int)XC + (long int)(zoom*xyz[0])+4;
 Y = YCC + (long int)YC - (long int)(zoom*xyz[1])-4;
 //Verifica che sia all'interno dei bordi dello schermo
 Col=getcolor();
 setcolor(color);
 if ((X>Wmx && X+8<WMx) && (Y>Wmy && Y+8<WMy)) {
     for (i=0;i<29;i++) Str[i]=0;
     strcpy(Str,str);
     lung=textwidth(Str);
     if (X+lung>WMx) {
	    LS=strlen(Str);
	    sp2=lung/LS+1;
	    sp1=WMx-X;
	    sp1=sp1/sp2;
	    Str[sp1]=0;
     }
     outtextxy(X,Y,Str);//interno
 }
 else                       return NOK;        //esterno
 setcolor(Col);

return OK;
}

// Tracciamento di un Cerchio in 3D stato=0 cerchio stato=1 cerchio pieno
int Circle3D(float xyz[],float rad,float XC,float YC,int color,int stato)
{
long int X,Y;
int      Col;

 X = XCC - (long int)XC + (long int)(zoom*xyz[0]);
 Y = YCC + (long int)YC - (long int)(zoom*xyz[1]);

 //Verifica che sia all'interno dei bordi dello schermo
 if ((X-rad>Wmx && X+rad<WMx) && (Y-rad>Wmy && Y+rad<WMy)) {
    Col=getcolor();
    setcolor(color);
    if (stato) {
       setfillstyle(SOLID_FILL,color);
       pieslice(X,Y,0,360,rad);
    }
    else       circle(X,Y,rad);//interno
    setcolor(Col);
 }
 else      return NOK;         //esterno

return OK;
}


// Tracciamento di una linea in 3D
int Line3D(float xyz1[],float xyz2[],float XC,float YC,int color)
{
int      Col,INTWIN;
float    x,y,xp,yp;
float    Fmx=Wmx,FMx=WMx,Fmy=Wmy,FMy=WMy;

 x  = (float)XCC - XC + zoom*xyz1[0];
 y  = (float)YCC + YC - zoom*xyz1[1];
 xp = (float)XCC - XC + zoom*xyz2[0];
 yp = (float)YCC + YC - zoom*xyz2[1];

 Col=getcolor();
 setcolor(color);
 //Verifica che sia all'interno dei bordi dello schermo
 INTWIN = clipping(&x,&y,&xp,&yp,&Fmx,&FMx,&Fmy,&FMy);
 if (INTWIN!=2) line ((int)x,(int)y,(int)xp,(int)yp);//interna
 else           return NOK;                              //esterna
 setcolor(Col);

return OK;
}

// Tracciamento di una sfera in 3D
// NOTE: Lon Numero di meridiani visibili
//       Lat Numero di Paralleli Visibili (o 1 o 3, se >3 assumo3)
//       Stato 0 : Sfera completa
//       Stato 1 : Solo la parte visibile della Sfera
int Sfera3D(float Centro[3],float Ray,int Lon,int Lat,float XC,float YC,int color,int Stato)
{
int    INTWIN;
float  x,y,xp,yp;
float  Fmx=Wmx,FMx=WMx,Fmy=Wmy,FMy=WMy;
int    intLon1,intLon2,intLat;
int    intLL;
float  PT1[3],PT2[3],lat[3]={0,-66.5,66.5};
float  XYZ[3],k;
int    i,j,Col;

 if (Lat!=1) Lat=3;
 if (Lon>24) Lon=24;
 intLL  = 18;
 intLon1= 360/intLL;
 intLat = 180/9;

 Col=getcolor();
 setcolor(color);
 ROTXYZ(Centro[0],Centro[1],Centro[2],&XYZ[0],&XYZ[1],&XYZ[2]);
 for (j=0;j<Lat;j++) { //cerchi di latitudine
    POLtoXYZ (0,lat[j],Ray,&PT1[0],&PT1[1],&PT1[2]);
    TRAXYZ (&PT1[0],&PT1[1],&PT1[2],Centro[0],Centro[1],Centro[2]);
    ROTXYZ(PT1[0],PT1[1],PT1[2],&PT1[0],&PT1[1],&PT1[2]);
    for (i=1;i<intLL;i++) {//long
		 POLtoXYZ (intLon1*i,lat[j],Ray,&PT2[0],&PT2[1],&PT2[2]);
       TRAXYZ (&PT2[0],&PT2[1],&PT2[2],Centro[0],Centro[1],Centro[2]);
       ROTXYZ(PT2[0],PT2[1],PT2[2],&PT2[0],&PT2[1],&PT2[2]);
       if (Stato) {
	  if (PT1[2]<XYZ[2] && PT2[2]<XYZ[2]);
	  else Line3D(PT1,PT2,XC,YC,color);
		 }
       else    Line3D(PT1,PT2,XC,YC,color);
       PT1[0]=PT2[0];PT1[1]=PT2[1];PT1[2]=PT2[2];
    }
    POLtoXYZ (360,lat[j],Ray,&PT2[0],&PT2[1],&PT2[2]);
    TRAXYZ (&PT2[0],&PT2[1],&PT2[2],Centro[0],Centro[1],Centro[2]);
    ROTXYZ(PT2[0],PT2[1],PT2[2],&PT2[0],&PT2[1],&PT2[2]);
    if (Stato) {
	  if (PT1[2]<XYZ[2] && PT2[2]<XYZ[2]);
	  else Line3D(PT1,PT2,XC,YC,color);
    }
    else    Line3D(PT1,PT2,XC,YC,color);
 }

 if (Lon) {
   intLon2= 360/Lon;
   for (j=0;j<360;j=j+intLon2) { //cerchi di longitudine
	  POLtoXYZ (j,-90,Ray,&PT1[0],&PT1[1],&PT1[2]);
     TRAXYZ (&PT1[0],&PT1[1],&PT1[2],Centro[0],Centro[1],Centro[2]);
     ROTXYZ(PT1[0],PT1[1],PT1[2],&PT1[0],&PT1[1],&PT1[2]);
     for (i=1;i<=intLL/2;i++) {//long
	POLtoXYZ (j,-90+i*intLat,Ray,&PT2[0],&PT2[1],&PT2[2]);
	TRAXYZ (&PT2[0],&PT2[1],&PT2[2],Centro[0],Centro[1],Centro[2]);
	ROTXYZ(PT2[0],PT2[1],PT2[2],&PT2[0],&PT2[1],&PT2[2]);
	if (Stato) {
	   if (PT1[2]<XYZ[2] && PT2[2]<XYZ[2]);
	   else Line3D(PT1,PT2,XC,YC,color);
	}
	else    Line3D(PT1,PT2,XC,YC,color);
	PT1[0]=PT2[0];PT1[1]=PT2[1];PT1[2]=PT2[2];
     }
     POLtoXYZ (j,90,Ray,&PT2[0],&PT2[1],&PT2[2]);
     TRAXYZ (&PT2[0],&PT2[1],&PT2[2],Centro[0],Centro[1],Centro[2]);
     ROTXYZ(PT2[0],PT2[1],PT2[2],&PT2[0],&PT2[1],&PT2[2]);
     if (Stato) {
	  if (PT1[2]<XYZ[2] && PT2[2]<XYZ[2]);
	  else Line3D(PT1,PT2,XC,YC,color);
     }
     else      Line3D(PT1,PT2,XC,YC,color);
   }
 }
 x =XCC - XC + zoom*XYZ[0] + Ray*zoom*sin(0);
 y =YCC + YC - zoom*XYZ[1] + Ray*zoom*cos(0);
 for (k=20;k<=360;k=k+20) { // Cerchi di Longitudine
     xp = XCC - XC + zoom*XYZ[0] + Ray*zoom*sin(GtoR(k));
     yp = YCC + YC - zoom*XYZ[1] + Ray*zoom*cos(GtoR(k));
	  INTWIN = clipping(&x,&y,&xp,&yp,&Fmx,&FMx,&Fmy,&FMy);
     if (INTWIN!=2) line ((int)x,(int)y,(int)xp,(int)yp);//interna
     x  = xp;	y  = yp;
 }

 setcolor(Col);
return OK;
}

// Tracciamento di un cilindro in 3D
// NOTE: Lung  : Deve avere solo una delle 3 lunghezze !=0
//       Centro: Coordinate centro cilindro
//       RayP  : Raggio Cerchio lugo l' asse positivo (0 se vertice di cono)
//       RayM  : Raggio Cerchio lugo l' asse negativo (0 se vertice di cono)
//       Bord  : N. di raggi che compongono il cerchio (consigliati almeno 12)
//       Stato 1 : Solo la parte visibile del Cilindro (0 tutto)
// ATTENZIONE: Non implementatala parte delle visibilita per Coni,Tronchi di cono
int Cilindro3D(float Lung[3],float Centro[3],float RayP,float RayM,float XC,float YC,int Bord,int color,int Stato)
{
int   i=0,Col,j=0,k,f;
float Ang,gr;
float xyzP[3],xyzM[3],xyzP1[3],xyzM1[3],supp[3],supp1[3];

 Col=getcolor();
 setcolor(color);

 if (Lung[0]) i++;
 if (Lung[1]) i++;
 if (Lung[2]) i++;
 if (i==0 || i>1) return NOK;
 gr=GtoR(360/Bord);
 if (Lung[0]){
    Ang=0;
    ROTXYZ(Centro[0]+Lung[0]/2,Centro[1],Centro[2],&supp [0],&supp [1],&supp [2]);
    ROTXYZ(Centro[0]-Lung[0]/2,Centro[1],Centro[2],&supp1[0],&supp1[1],&supp1[2]);
    if (supp[2]>supp1[2]) k=0;
    else                  k=1;
    do {
       xyzP[0]=Centro[0]+Lung[0]/2;
       xyzM[0]=Centro[0]-Lung[0]/2;
		 xyzP[1]=Centro[1]+RayP*sin(Ang);
       xyzP[2]=Centro[2]+RayP*cos(Ang);
       xyzM[1]=Centro[1]+RayM*sin(Ang);
       xyzM[2]=Centro[2]+RayM*cos(Ang);
       ROTXYZ(xyzP[0],xyzP[1],xyzP[2],&xyzP[0],&xyzP[1],&xyzP[2]);
       ROTXYZ(xyzM[0],xyzM[1],xyzM[2],&xyzM[0],&xyzM[1],&xyzM[2]);
		 if (j) {
	   f=0;
	   if (Stato) {
	      if (k) {
		  if (xyzP[2]>=supp[2]-RayP/(Bord*2)) {
		      Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
		      f=1;
		  }
	      }
	      else   Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
	      if (k) Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
	      else{
		  if (xyzM[2]>=supp1[2]-RayM/(Bord*2)) {
		      Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
		      f=1;
		  }
	      }
			if (f) Line3D(xyzP,xyzM,XC,YC,color); //direttrici
	   }
	   else {
	      Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
	      Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
	      Line3D(xyzP,xyzM,XC,YC,color); //direttrici
		}
       }
       else  j++;
       Ang=Ang+gr;
       xyzP1[0]=xyzP[0];xyzP1[1]=xyzP[1];xyzP1[2]=xyzP[2];
       xyzM1[0]=xyzM[0];xyzM1[1]=xyzM[1];xyzM1[2]=xyzM[2];
    } while (Ang<=2*M_PI);
    Ang=0;
    xyzP[0]=Centro[0]+Lung[0]/2;
    xyzM[0]=Centro[0]-Lung[0]/2;
    xyzP[1]=Centro[1]+RayP*sin(Ang);
    xyzP[2]=Centro[2]+RayP*cos(Ang);
    xyzM[1]=Centro[1]+RayM*sin(Ang);
    xyzM[2]=Centro[2]+RayM*cos(Ang);
    ROTXYZ(xyzP[0],xyzP[1],xyzP[2],&xyzP[0],&xyzP[1],&xyzP[2]);
    ROTXYZ(xyzM[0],xyzM[1],xyzM[2],&xyzM[0],&xyzM[1],&xyzM[2]);
    if (Stato) {
	if (k) {
		  if (xyzP[2]>=supp[2]-RayP/(Bord*2)) {
		      Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
		      f=1;
		  }
	   }
		else   Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
	   if (k) Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
	   else{
		  if (xyzM[2]>=supp1[2]-RayM/(Bord*2)) {
		      Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
		      f=1;
		  }
	}
	if (f) Line3D(xyzP,xyzM,XC,YC,color); //direttrici
    }
    else {
	Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
	Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
	Line3D(xyzP,xyzM,XC,YC,color); //direttrici
    }
 }
 if (Lung[1]){
	 Ang=0;
    ROTXYZ(Centro[0],Centro[1]+Lung[1]/2,Centro[2],&supp [0],&supp [1],&supp [2]);
    ROTXYZ(Centro[0],Centro[1]-Lung[1]/2,Centro[2],&supp1[0],&supp1[1],&supp1[2]);
    if (supp[2]>supp1[2]) k=0;
    else                  k=1;
    do {
		 xyzP[0]=Centro[0]+RayP*sin(Ang);
       xyzM[0]=Centro[0]+RayM*sin(Ang);
       xyzP[1]=Centro[1]+Lung[1]/2;
       xyzP[2]=Centro[2]+RayP*cos(Ang);
       xyzM[1]=Centro[1]-Lung[1]/2;
       xyzM[2]=Centro[2]+RayM*cos(Ang);
       ROTXYZ(xyzP[0],xyzP[1],xyzP[2],&xyzP[0],&xyzP[1],&xyzP[2]);
       ROTXYZ(xyzM[0],xyzM[1],xyzM[2],&xyzM[0],&xyzM[1],&xyzM[2]);
       if (j) {
	   f=0;
	   if (Stato) {
	      if (k) {
		  if (xyzP[2]>=supp[2]-RayP/(Bord*2)) {
		      Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
		      f=1;
		  }
	      }
			else   Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
	      if (k) Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
	      else{
		  if (xyzM[2]>=supp1[2]-RayM/(Bord*2)) {
		      Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
		      f=1;
		  }
	      }
	      if (f) Line3D(xyzP,xyzM,XC,YC,color); //direttrici
		}
	   else {
	      Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
	      Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
	      Line3D(xyzP,xyzM,XC,YC,color); //direttrici
	   }
       }
       else  j++;
       Ang=Ang+gr;
       xyzP1[0]=xyzP[0];xyzP1[1]=xyzP[1];xyzP1[2]=xyzP[2];
       xyzM1[0]=xyzM[0];xyzM1[1]=xyzM[1];xyzM1[2]=xyzM[2];
    } while (Ang<=2*M_PI);
    xyzP[0]=Centro[0]+RayP*sin(Ang);
    xyzM[0]=Centro[0]+RayM*sin(Ang);
	 xyzP[1]=Centro[1]+Lung[1]/2;
    xyzP[2]=Centro[2]+RayP*cos(Ang);
    xyzM[1]=Centro[1]-Lung[1]/2;
    xyzM[2]=Centro[2]+RayM*cos(Ang);
    ROTXYZ(xyzP[0],xyzP[1],xyzP[2],&xyzP[0],&xyzP[1],&xyzP[2]);
    ROTXYZ(xyzM[0],xyzM[1],xyzM[2],&xyzM[0],&xyzM[1],&xyzM[2]);
	 if (Stato) {
	if (k) {
		  if (xyzP[2]>=supp[2]-RayP/(Bord*2)) {
		      Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
		      f=1;
		  }
	   }
	   else   Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
		if (k) Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
	   else{
		  if (xyzM[2]>=supp1[2]-RayM/(Bord*2)) {
		      Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
		      f=1;
		  }
	}
	if (f) Line3D(xyzP,xyzM,XC,YC,color); //direttrici
    }
	 else {
	Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
	Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
	Line3D(xyzP,xyzM,XC,YC,color); //direttrici
    }
 }
 if (Lung[2]){
    Ang=0;
    ROTXYZ(Centro[0],Centro[1],Centro[2]+Lung[2]/2,&supp [0],&supp [1],&supp [2]);
    ROTXYZ(Centro[0],Centro[1],Centro[2]-Lung[2]/2,&supp1[0],&supp1[1],&supp1[2]);
    if (supp[2]>supp1[2]) k=0;
    else                  k=1;
    do {
       xyzP[0]=Centro[0]+RayP*sin(Ang);
       xyzM[0]=Centro[0]+RayM*sin(Ang);
       xyzP[1]=Centro[1]+RayP*cos(Ang);
       xyzP[2]=Centro[2]+Lung[2]/2;;
       xyzM[1]=Centro[1]+RayM*cos(Ang);
       xyzM[2]=Centro[2]-Lung[2]/2;
		 ROTXYZ(xyzP[0],xyzP[1],xyzP[2],&xyzP[0],&xyzP[1],&xyzP[2]);
       ROTXYZ(xyzM[0],xyzM[1],xyzM[2],&xyzM[0],&xyzM[1],&xyzM[2]);
       if (j) {
	   f=0;
		if (Stato) {
	      if (k) {
		  if (xyzP[2]>=supp[2]-RayP/(Bord*2)) {
		      Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
		      f=1;
		  }
			}
	      else   Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
	      if (k) Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
	      else{
		  if (xyzM[2]>=supp1[2]-RayM/(Bord*2)) {
		      Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
		      f=1;
		  }
	      }
	      if (f) Line3D(xyzP,xyzM,XC,YC,color); //direttrici
	   }
	   else {
	      Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
	      Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
	      Line3D(xyzP,xyzM,XC,YC,color); //direttrici
	   }
       }
		 else  j++;
		 Ang=Ang+gr;
       xyzP1[0]=xyzP[0];xyzP1[1]=xyzP[1];xyzP1[2]=xyzP[2];
       xyzM1[0]=xyzM[0];xyzM1[1]=xyzM[1];xyzM1[2]=xyzM[2];
    } while (Ang<=2*M_PI);
    xyzP[0]=Centro[0]+RayP*sin(Ang);
    xyzM[0]=Centro[0]+RayM*sin(Ang);
    xyzP[1]=Centro[1]+RayP*cos(Ang);
    xyzP[2]=Centro[2]+Lung[2]/2;;
    xyzM[1]=Centro[1]+RayM*cos(Ang);
    xyzM[2]=Centro[2]-Lung[2]/2;
    ROTXYZ(xyzP[0],xyzP[1],xyzP[2],&xyzP[0],&xyzP[1],&xyzP[2]);
    ROTXYZ(xyzM[0],xyzM[1],xyzM[2],&xyzM[0],&xyzM[1],&xyzM[2]);
    if (Stato) {
	if (k) {
		  if (xyzP[2]>=supp[2]-RayP/(Bord*2)) {
		      Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
		      f=1;
		  }
	   }
	   else   Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
	   if (k) Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
	   else{
		  if (xyzM[2]>=supp1[2]-RayM/(Bord*2)) {
		      Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
		      f=1;
		  }
	}
	if (f) Line3D(xyzP,xyzM,XC,YC,color); //direttrici
	 }
    else {
	Line3D(xyzP1,xyzP,XC,YC,color);//cerchio1
	Line3D(xyzM1,xyzM,XC,YC,color);//cerchio2
	Line3D(xyzP,xyzM,XC,YC,color); //direttrici
    }
 }
 setcolor(Col);
return OK;
}

//Definizione di un piano in 3D
int NDefPian(CUBE *Elem,float LarLunAlt[3],float Centro[3])
{
int i;

 if (LarLunAlt[0]==0 && LarLunAlt[1]==0 && LarLunAlt[2]==0) return NOK;
 if (LarLunAlt[2]==0) {
	Elem->pti[0][0]= Centro[0]+LarLunAlt[0]/2;
	Elem->pti[0][1]= Centro[1]+LarLunAlt[1]/2;
	Elem->pti[1][0]= Centro[0]+LarLunAlt[0]/2;
	Elem->pti[1][1]= Centro[1]-LarLunAlt[1]/2;
	Elem->pti[2][0]= Centro[0]-LarLunAlt[0]/2;
	Elem->pti[2][1]= Centro[1]-LarLunAlt[1]/2;
	Elem->pti[3][0]= Centro[0]-LarLunAlt[0]/2;
	Elem->pti[3][1]= Centro[1]+LarLunAlt[1]/2;
	for (i=0;i<4;i++) Elem->pti[i][2]=Centro[2];
 }
 if (LarLunAlt[0]==0) {
	Elem->pti[0][1]= Centro[1]+LarLunAlt[1]/2;
	Elem->pti[0][2]= Centro[2]-LarLunAlt[2]/2;
	Elem->pti[1][1]= Centro[1]-LarLunAlt[1]/2;
	Elem->pti[1][2]= Centro[2]-LarLunAlt[2]/2;
	Elem->pti[2][1]= Centro[1]-LarLunAlt[1]/2;
	Elem->pti[2][2]= Centro[2]+LarLunAlt[2]/2;
	Elem->pti[3][1]= Centro[1]+LarLunAlt[1]/2;
	Elem->pti[3][2]= Centro[2]+LarLunAlt[2]/2;
	for (i=0;i<4;i++) Elem->pti[i][0]=Centro[0];
 }
 if (LarLunAlt[1]==0) {
	Elem->pti[0][0]= Centro[0]+LarLunAlt[0]/2;
	Elem->pti[0][2]= Centro[2]-LarLunAlt[2]/2;
	Elem->pti[1][0]= Centro[0]+LarLunAlt[0]/2;
	Elem->pti[1][2]= Centro[2]+LarLunAlt[2]/2;
	Elem->pti[2][0]= Centro[0]-LarLunAlt[0]/2;
	Elem->pti[2][2]= Centro[2]+LarLunAlt[2]/2;
	Elem->pti[3][0]= Centro[0]-LarLunAlt[0]/2;
	Elem->pti[3][2]= Centro[2]-LarLunAlt[2]/2;
	for (i=0;i<4;i++) Elem->pti[i][1]=Centro[1];
 }
return OK;
}

// Tracciamento di un piano in 3D
int NPiano3D(CUBE *Elem,float XC,float YC,int color)
{
float PTT[4][3];
float XYZ[3];
int   i,Col;

 Col=getcolor();
 for (i=0;i<4;i++) {
	 XYZ[0]=Elem->pti[i][0];
	 XYZ[1]=Elem->pti[i][1];
	 XYZ[2]=Elem->pti[i][2];
	 ROTXYZ(XYZ[0],XYZ[1],XYZ[2],&PTT[i][0],&PTT[i][1],&PTT[i][2]);
 }
 Line3D(PTT[0],PTT[1],XC,YC,color);
 Line3D(PTT[1],PTT[2],XC,YC,color);
 Line3D(PTT[2],PTT[3],XC,YC,color);
 Line3D(PTT[3],PTT[0],XC,YC,color);

 setcolor(Col);
return OK;
}

//Definizione di un parallelogramma in 3D
void NDefCub(CUBE *Elem,float LarLunAlt[3],float Centro[3])
{
 Elem->pti[0][0]= Centro[0]+LarLunAlt[0]/2;
 Elem->pti[0][1]= Centro[1]+LarLunAlt[1]/2;
 Elem->pti[0][2]= Centro[2]-LarLunAlt[2]/2;
 Elem->pti[1][0]= Centro[0]+LarLunAlt[0]/2;
 Elem->pti[1][1]= Centro[1]-LarLunAlt[1]/2;
 Elem->pti[1][2]= Centro[2]-LarLunAlt[2]/2;
 Elem->pti[2][0]= Centro[0]+LarLunAlt[0]/2;
 Elem->pti[2][1]= Centro[1]-LarLunAlt[1]/2;
 Elem->pti[2][2]= Centro[2]+LarLunAlt[2]/2;
 Elem->pti[3][0]= Centro[0]+LarLunAlt[0]/2;
 Elem->pti[3][1]= Centro[1]+LarLunAlt[1]/2;
 Elem->pti[3][2]= Centro[2]+LarLunAlt[2]/2;

 Elem->pti[4][0]= Centro[0]-LarLunAlt[0]/2;
 Elem->pti[4][1]= Centro[1]+LarLunAlt[1]/2;
 Elem->pti[4][2]= Centro[2]-LarLunAlt[2]/2;
 Elem->pti[5][0]= Centro[0]-LarLunAlt[0]/2;
 Elem->pti[5][1]= Centro[1]-LarLunAlt[1]/2;
 Elem->pti[5][2]= Centro[2]-LarLunAlt[2]/2;
 Elem->pti[6][0]= Centro[0]-LarLunAlt[0]/2;
 Elem->pti[6][1]= Centro[1]-LarLunAlt[1]/2;
 Elem->pti[6][2]= Centro[2]+LarLunAlt[2]/2;
 Elem->pti[7][0]= Centro[0]-LarLunAlt[0]/2;
 Elem->pti[7][1]= Centro[1]+LarLunAlt[1]/2;
 Elem->pti[7][2]= Centro[2]+LarLunAlt[2]/2;

}

// Tracciamento di un parallelepipedo in 3D
int NCubo3D(CUBE *Elem,float XC,float YC,int color,int Stato)
{
float PTT[8][3],Max;
float XYZ[3];
int   i,k,f[3],Col;

 Col=getcolor();
 for (i=0;i<8;i++) {
    XYZ[0]=Elem->pti[i][0];
    XYZ[1]=Elem->pti[i][1];
	 XYZ[2]=Elem->pti[i][2];
    ROTXYZ(XYZ[0],XYZ[1],XYZ[2],&PTT[i][0],&PTT[i][1],&PTT[i][2]);
 }
 if (Stato==0) {
     for (i=0;i<4;i++) Line3D(PTT[i],PTT[i+4],XC,YC,color);
     for (i=0;i<3;i++) {
	Line3D(PTT[i],PTT[i+1],XC,YC,color);
	Line3D(PTT[i+4],PTT[i+5],XC,YC,color);
     }
     Line3D(PTT[3],PTT[0],XC,YC,color);
     Line3D(PTT[7],PTT[4],XC,YC,color);
 }
 else{
     Max=PTT[0][2]; k=0;
     for (i=1;i<8;i++) if (PTT[i][2]>Max) { k=i; Max=PTT[i][2]; }
     if (k>=4) {//faccia davanti  >=4
	for (i=0;i<3;i++) Line3D(PTT[i+4],PTT[i+5],XC,YC,color);
	Line3D(PTT[7],PTT[4],XC,YC,color);
	f[0]=k-1;f[1]=k;f[2]=k+1;
	if (k==4)      f[0]=7;
	else if (k==7) f[2]=4;
	for (i=0;i<3;i++) Line3D(PTT[f[i]],PTT[f[i]-4],XC,YC,color);//laterali
	Line3D(PTT[f[0]-4],PTT[f[1]-4],XC,YC,color);//laterali
	Line3D(PTT[f[1]-4],PTT[f[2]-4],XC,YC,color);//laterali
     }
     else {
	for (i=0;i<3;i++) Line3D(PTT[i],PTT[i+1],XC,YC,color);//base
	Line3D(PTT[3],PTT[0],XC,YC,color);
	f[0]=k-1;f[1]=k;f[2]=k+1;
	if (k==3)      f[2]=0;
	else if (k==0) f[0]=3;
	for (i=0;i<3;i++) Line3D(PTT[f[i]],PTT[f[i]+4],XC,YC,color);//laterali
	Line3D(PTT[f[0]+4],PTT[f[1]+4],XC,YC,color);//laterali
	Line3D(PTT[f[1]+4],PTT[f[2]+4],XC,YC,color);//laterali
     }
 }
 setcolor(Col);
return OK;
}

