#include "math.h"
#include "stdlib.h"

    /* ###################### 3D LIB ########################### */
extern float Alfa,Beta,Gamma; //angoli di rotazione assi x,y,z
extern float zoom;            //angoli di rotazione assi x,y,z
extern int   WMx,Wmx,WMy,Wmy; //Bordi della finestra ATTIVA per disegnare
extern int   XCC,YCC;         //Coord centro schermo

/* ########################## 3D LIB FUNCTION ################## */
typedef struct Cube {
		float pti[8][3];
} CUBE;
//NB il primo punto rappresenta il centro, la var. sono cosi usate:
//Centro[3] sono le coordinate del centro
//Lung[3] sono i semafori che indicano quale sia l' asse zenitale (+/-)
//Lon,Lat,stato sono gradi,minuti,secondi del max angolo zenitale
typedef struct Elements {
   int    TypeObj;     //0-Centro XYZ, 1-Piano, 2-Cubo, 3-Sfera, 4-Cilindro
   CUBE   Obj;         //Punti del: Piano, Cubo
   float  Centro[3];   //Centro dell'oggetto
   float  Lung[3];     //Lunghezza, Larghezza, Altezza
   float  Ray1,Ray2;   //Raggio sfera oppure Raggio 2 Cerchi del Cilindro
		    //Attenzione Ray2 non usato sino a che implemento il Cono
		    //Viene quindi usato per segnalare se l'elemento e' visibile
		    //dal nostro strumento oppure no vedi elements.c-> ElemEstAng();
   int    Lon,Lat;     //NUmero di Meridiani e Paralleli
   int    color;       //Colore oggetto
   int    stato;       //Visibilita' parti nascoste Si/No
   struct Elements *succ;
} ELEMENTS;
extern ELEMENTS *iniz,*last,*iniz1,*last1;

//Aggiunge (non crea) un elemento (bisogna infatti mallocarlo prima)
extern void Memor(struct Elements *punt,int Caso);

//Toglie (non cancella) un elemento (bisogna infatti freearlo poi)
extern struct Elements *Cancel(struct Elements *Prec,struct Elements *Canc,struct Elements *Cima);

//Resetta elemento (pone tutto a 0)
extern void Reset(struct Elements *punt);

//portabile Trasformazione Gradi->Radianti
extern double GtoR (register double gradi);

//portabile Trasformazione Radianti->Gradi
extern double RtoG (register double radianti);

//portabile Trasformazione Gradi->Ore Decimali
extern double GtoH (register double gradi);

//portabile Trasformazione Ore Decimali->Gradi
extern double HtoG (register double ore);

extern int Code (float *x,float *y,float *Minx,float *Maxx,float *Miny,float *Maxy);

extern double ClipDX(register float *Maxx,register float *x,register float *y,
				  register float *x0,register float *y0);

extern double ClipSX(register float *Minx,register float *x,register float *y,
				  register float *x0,register float *y0);

extern double ClipTOP(register float *Maxy,register float *x,register float *y,
					register float *x0,register float *y0);

extern double ClipBOT(register float *Miny,register float *x,register float *y,
					register float *x0,register float *y0);

//portabile algoritmo di clipping sia 2D che a 3D
extern int clipping (float *x1,float *y1,float *x2,float *y2,
	      float *Minx,float *Maxx,float *Miny,float *Maxy);
//Portabile rotazione degli assi
extern void ROTXYZ  (float X,float Y,float Z,float *XT,float *YT,float *ZT);

//Traslazione assi in 3D
extern void TRAXYZ (float *OldX,float *OldY,float *OldZ,float TraslaX,float TraslaY,float TraslaZ);

//Portabile traccia un p.to in 3D in una finestra
extern int Point3D  (float xyz[],float XC,float YC,int color);

//Portabile inserisce un testo relativo ad un p.to in 3D in una finestra
extern int OText3D  (float xyz[],float XC,float YC,int color,char str[]);

// Portabile Tracciamento di un Cerchio in 3D
extern int Circle3D (float xyz[],float rad,float XC,float YC,int color,int Stato);

//Portabile traccia una retta in 3D in una finestra
extern int Line3D   (float xyz1[],float xyz2[],float XC,float YC,int color);

// Tracciamento di una sfera in 3D
//int Sfera3D(float Xc,float Yc,float Ray,int Lon,int Lat,float XC,float YC,int color,int Stato);
extern int Sfera3D(float Centro[],float Ray,int Lon,int Lat,float XC,float YC,int color,int Stato);

//Conversione da Coord.Polari->Coord.Cartesiane
extern void POLtoXYZ (float Lon,float Lat,float Dis,float *x,float *y,float *z);

//Conversione da Coord.Cartesiane->Coord.Polari
//controllare ed ultimare Lon
extern void XYZtoPOL (float x,float y,float z,float *Lon,float *Lat,float *Dis);

//Distanza 2 p.ti nello spazio
extern float Dist3D (float x1,float y1,float z1,float x,float y,float z);

//Definizione di un piano in 3D
extern int NDefPian(CUBE *Elem,float LarLunAlt[3],float Centro[3]);

// Tracciamento di un piano in 3D
extern int NPiano3D(CUBE *Elem,float XC,float YC,int color);

//Definizione di un parallelogramma in 3D
extern void NDefCub(CUBE *Elem,float LarLunAlt[3],float Centro[3]);

// Tracciamento di un parallelepipedo in 3D
extern int NCubo3D(CUBE *Elem,float XC,float YC,int color,int Stato);

// Tracciamento di un cilindro in 3D
extern int Cilindro3D(float Lung[3],float Centro[3],float RayP,float RayM,
			 float XC,float YC,int Bord,int color,int Stato);
